/**
 * Rg[plNX
 */

package hydrogen;

import java.awt.*;
import java.awt.event.*;
import java.text.DecimalFormat;
import library.graphics.*;

class ControlPanel extends Panel implements ActionListener, AdjustmentListener, ItemListener, MouseListener, MouseMotionListener {
    int res;
    double theta, phi, intensity, reduction, step;
    boolean changed = true, moved = false, highres = false;
    private int n, l, m, mouse_x, mouse_y;
    private double scale;
    private boolean link = true, reset_low = true, reset_high = true;

    private ElectronDensity ed_low, ed_high;

    private Button btn_draw, btn_x, btn_y, btn_z;
    private Label lbl_orb, lbl_n, lbl_l, lbl_m, lbl_sc;
    private Scrollbar sb_n, sb_l, sb_m, sb_sc, sb_it, sb_rd;
    private Checkbox cb_link;
    private Checkbox[] cb_res = new Checkbox[3];
    private Checkbox[] cb_quality = new Checkbox[3];

    private String[] orb = {
        "s", "p", "d", "f", "g", "h", "i"
    };

    ControlPanel(ElectronDensity ed_low, ElectronDensity ed_high) {
        this.ed_low = ed_low;
        this.ed_high = ed_high;

        n = 3; l = 2; m = 0;
        theta = 0.9; phi = 0.78;
        res = 100; step = 0.008;

        Font font = new Font("SansSerif", Font.PLAIN, 16);
        setLayout(new GridLayout(9, 1));

        lbl_orb = new Label("ʎqݒ", Label.CENTER);
        lbl_orb.setFont(font);
        add(lbl_orb);

        Panel pnl1 = new Panel(new GridLayout(2, 2));
            pnl1.add(lbl_n = new Label());
            pnl1.add(sb_n = new Scrollbar(Scrollbar.HORIZONTAL, n, 1, 1, 8));
            pnl1.add(lbl_l = new Label());
            pnl1.add(sb_l = new Scrollbar(Scrollbar.HORIZONTAL, l, 1, 0, n));
        add(pnl1);

        Panel pnl2 = new Panel(new GridLayout(2, 2));
            pnl2.add(lbl_m = new Label());
            pnl2.add(sb_m = new Scrollbar(Scrollbar.HORIZONTAL, m, 1, -l, l+1));
            pnl2.add(lbl_sc = new Label());
            pnl2.add(sb_sc = new Scrollbar(Scrollbar.HORIZONTAL, 10, 1, 10, 2201));
        add(pnl2);

        Label lbl_view = new Label("\ݒ", Label.CENTER);
        lbl_view.setFont(font);
        add(lbl_view);

        Panel pnl3 = new Panel(new GridLayout(2, 2));
            pnl3.add(new Label("̋x"));
            pnl3.add(sb_it = new Scrollbar(Scrollbar.HORIZONTAL, 20, 1, 20, 181));
            pnl3.add(new Label("̌W"));
            pnl3.add(sb_rd = new Scrollbar(Scrollbar.HORIZONTAL, 20, 1, 20, 181));
        add(pnl3);

        Panel pnl4 = new Panel(new GridLayout(2, 1));
            pnl4.add(cb_link = new Checkbox("̋xƌW̘A", link));
            Panel pnl41 = new Panel(new GridLayout(1, 2));
            pnl41.add(new Label("_̃Zbg"));
            Panel pnl42 = new Panel(new GridLayout(1, 3));
                pnl42.add(btn_x = new Button("x "));
                pnl42.add(btn_y = new Button("y "));
                pnl42.add(btn_z = new Button("z "));
            pnl41.add(pnl42);
            pnl4.add(pnl41);
        add(pnl4);

        Label lbl_qual = new Label("iݒ", Label.CENTER);
        lbl_qual.setFont(font);
        add(lbl_qual);

        Panel pnl5 = new Panel(new GridLayout(2, 4));
            pnl5.add(new Label("𑜓x"));
            CheckboxGroup cbg_res = new CheckboxGroup();
            pnl5.add(cb_res[0] = new Checkbox("400", false, cbg_res));
            pnl5.add(cb_res[1] = new Checkbox("200", false, cbg_res));
            pnl5.add(cb_res[2] = new Checkbox("100", true, cbg_res));
            pnl5.add(new Label("i"));
            CheckboxGroup cbg_quality = new CheckboxGroup();
            pnl5.add(cb_quality[0] = new Checkbox("", false, cbg_quality));
            pnl5.add(cb_quality[1] = new Checkbox("", false, cbg_quality));
            pnl5.add(cb_quality[2] = new Checkbox("", true, cbg_quality));
        add(pnl5);

        add(btn_draw = new Button("`"));

        btn_draw.addActionListener(this);
        btn_x.addActionListener(this);
        btn_y.addActionListener(this);
        btn_z.addActionListener(this);
        sb_n.addAdjustmentListener(this);
        sb_l.addAdjustmentListener(this);
        sb_m.addAdjustmentListener(this);
        sb_sc.addAdjustmentListener(this);
        sb_it.addAdjustmentListener(this);
        sb_rd.addAdjustmentListener(this);
        cb_link.addItemListener(this);
        for(int i=0; i<3; i++) {
            cb_res[i].addItemListener(this);
            cb_quality[i].addItemListener(this);
        }

        setOrbital(true);
    }

    private void setOrbital(boolean adj) {
        if(adj) {
            int i;
            i = (int)((4.75*n*n - 4.18*n + 3.29)*10.0 + 0.5);
            sb_sc.setValue(i);
            i = (int)((6.7*Math.log(n) + 2.8)*10.0 + 0.5);
            sb_it.setValue(i);
            sb_rd.setValue(i);
        }

        scale = sb_sc.getValue() / 10.0;
        intensity = Math.exp(sb_it.getValue() / 10.0) * 1.5;
        reduction = Math.exp(sb_rd.getValue() / 10.0);

        lbl_orb.setText("ʎqݒ : " + Integer.toString(n) + orb[l]);
        lbl_n.setText("ʎq@ : " + Integer.toString(n));
        lbl_l.setText("ʗʎq : " + Integer.toString(l));
        lbl_m.setText("Cʎq : " + Integer.toString(m));
        lbl_sc.setText("XP[ : " + new DecimalFormat("0.0").format(scale));

        if(reset_low) {
            ed_low.setData(1, n, l, m, scale/2.0);
            reset_low = false;
        }
    }

    public void actionPerformed(ActionEvent e) {
        Object object = e.getSource();

        if(object == btn_x) {
            theta = Math.PI/2;
            phi = 0.0;
            changed = true;
        } else if(object == btn_y) {
            theta = Math.PI/2;
            phi = Math.PI/2;
            changed = true;
        } else if(object == btn_z) {
            theta = 0.0;
            phi = 0.0;
            changed = true;
        } else {
            if(reset_high) {
                ed_high.setData(1, n, l, m, scale/2.0);
                reset_high = false;
            }
            highres = true;
        }
    }

    public void adjustmentValueChanged(AdjustmentEvent e) {
        Object object = e.getSource();

        if(object == sb_it || object == sb_rd) {
            if(link) {
                if(object == sb_it) sb_rd.setValue(sb_it.getValue());
                else sb_it.setValue(sb_rd.getValue());
            }
        } else {
            if(object == sb_n || object == sb_l) {
                n = sb_n.getValue();
                l = sb_l.getValue();

                if(l > n-1) l = n-1;
                if(m > l) m = l;
                else if(m < -l) m = -l;
                sb_l.setMaximum(n);
                sb_m.setMinimum(-l);
                sb_m.setMaximum(l+1);
            } else {
                m = sb_m.getValue();
            }
            reset_low = true;
            reset_high = true;
        }

        if(object == sb_n) setOrbital(true);
        else setOrbital(false);

        changed = true;
    }

    public void itemStateChanged(ItemEvent e) {
        Object object = e.getSource();

        if(object == cb_link) link = !link;
        else if(object == cb_res[0]) res = 400;
        else if(object == cb_res[1]) res = 200;
        else if(object == cb_res[2]) res = 100;
        else if(object == cb_quality[0]) step = 0.002;
        else if(object == cb_quality[1]) step = 0.004;
        else if(object == cb_quality[2]) step = 0.008;
    }

    public void mouseClicked(MouseEvent e) {
    }
    public void mouseEntered(MouseEvent e) {
    }
    public void mouseExited(MouseEvent e) {
    }
    public void mousePressed(MouseEvent e) {
        mouse_x = e.getX();
        mouse_y = e.getY();
        moved = true;
    }
    public void mouseReleased(MouseEvent e) {
        moved = false;
    }
    public void mouseDragged(MouseEvent e) {
        theta += (e.getY() - mouse_y) / 100.0;
        phi += (e.getX() - mouse_x) / 100.0;
        mouse_x = e.getX();
        mouse_y = e.getY();
    }
    public void mouseMoved(MouseEvent e) {
    }
}