/**
 * dqxNX
 */

package hydrogen;

import library.graphics.*;

class ElectronDensity extends Voxel {
    ElectronDensity(int num) {
        super(num);
    }

    void setData(int Z, int n, int l, int m, double scale) {
        double x, y, z, psi;
        for(int i=0; i < num + 1; i++)
            for(int j=0; j < num + 1; j++)
                for(int k=0; k < num + 1; k++) {
                    x = scale * (2*i - num)/num;
                    y = scale * (2*j - num)/num;
                    z = scale * (2*k - num)/num;
                    psi = Psi(Z, n, l, m, x, y, z);
                    if(psi < 0) density[i][j][k] = (float)(- psi * psi);
                    else density[i][j][k] = (float)(psi * psi);
                }
    }

    //g֐
    private double Psi(int Z, int n, int l, int m, double x, double y, double z) {
        double r = Math.sqrt(x*x + y*y + z*z);
        double rxy = Math.sqrt(x*x + y*y);
        double eimphi;

        if(r < 1.0E-10) r = 1.0E-10;
        if(rxy < 1.0E-10) rxy = 1.0E-10;

        double phi = Math.acos(x/rxy);
        if(y < 0) phi *= -1.0;
        if(m < 0) eimphi = Math.sin(m*phi);
        else eimphi = Math.cos(m*phi);

        return R(Z, n, l, r) * Y(l, m, z/r, eimphi);
    }

    //a֐iqPʌnj
    private double R(int Z, int n, int l, double r) {
        return
            - Math.sqrt(pow(2.0*Z/n, 3) * fact(n - l - 1) / (2*n*pow(fact(n + l), 3)))
            * Math.exp(-Z*r/n) * pow(2*Z*r/n, l) * L(n + l, 2*l + 1, 2*Z*r/n);
    }

    //ʒa֐
    private double Y(int l, int m, double costheta, double eimphi) {
        m = Math.abs(m);
        return
            Math.sqrt((2*l + 1)*fact(l - m) / (2.0*fact(l + m))) * P(l, m, costheta) * 1.0/Math.sqrt(2*3.14) * eimphi;
    }

    //Legendre֐iQɂvZj
    private double P(int n, int m, double x) {
        if(m%2 == 1 || m == 0)
            if(n == m)
                if(m == 0) return 1.0;
                else return - fact(2*m) / (pow(2.0, m) * fact(m)) * pow(Math.sqrt(1 - x*x), m);
            else if(n == m + 1) return (2*m + 1) * x * P(n - 1, m, x);
            else return 1.0/(n - m) * ((2*n - 1) * x * P(n - 1, m, x) - (n + m - 1) * P(n - 2, m, x));
        else
            if(x > -0.5 && x < 0.5)
                if(n == m) return - 2*(m - 1) * x / Math.sqrt(1 - x*x) * P(n, m - 1, x) - (n + m - 1) * (n - m + 2) * P(n, m - 2, x);
                else if(n == m + 1) return (2*m + 1) * x * P(n - 1, m, x);
                else return 1.0/(n - m) * ((2*n - 1) * x * P(n - 1, m, x) - (n + m - 1) * P(n - 2, m, x));
            else
                if(n == m) return 1.0/((2*m + 1) * x) * P(n + 1, m, x);
                else return - Math.sqrt(1 - x*x) / (2*m*x) * (P(n, m + 1, x) + (n + m) * (n - m + 1) * P(n, m - 1, x));
    }

    //Laguerre
    private double L(int n, int m, double x) {
        double l = 0.0;
        for(int i=0; i < n-m+1; i++)
            l += pow(-1.0, i + m) * pow(fact(n), 2) / (fact(i) * fact(i + m) * fact(n - m - i)) * pow(x, i);
        return l;
    }

    //n̊K
    private int fact(int n) {
        if(n == 0) return 1;
        else return n*fact(n - 1);
    }

    //ab
    private double pow(double a, int b) {
        double p = 1.0;
        for(; b>0; b--) p *= a;
        return p;
    }
}