/**
 * fq̌qO
 * Created on 2005/02/20
 * @author Takuya (http://clustera.skr.jp/java/)
 * @version 1.6
 */

package hydrogen;

import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import library.graphics.*;

public class Hydrogen extends Applet implements Runnable {
    ElectronDensity ed_low = new ElectronDensity(16);
    ElectronDensity ed_high = new ElectronDensity(128);
    private VRenderer renderer = new VRenderer(this, 400);
    private ControlPanel cp = new ControlPanel(ed_low, ed_high);
    private Thread th;

    public void init() {
        setLayout(null);
        add(cp);
        cp.setBounds(400, 0, 200, 400);
        setSize(600, 400);

        if(th == null) {
            th = new Thread(this);
            th.start();
        }
        addMouseListener(cp);
        addMouseMotionListener(cp);
    }

    public void paint(Graphics g) {
        if(cp.changed || cp.moved) {
            renderer.setLookAt(5.0, cp.theta, cp.phi);
            renderer.setCube(true);
            renderer.setLight(cp.intensity, cp.reduction);
            renderer.setQuality(50, 0.05);
            renderer.raytrace(ed_low);
            cp.changed = false;
        } else if(cp.highres){
            renderer.setCube(false);
            renderer.setQuality(cp.res, cp.step);
            renderer.raytrace(ed_high);
            cp.highres = false;
        }
        renderer.draw(g);
    }

    public void update(Graphics g) {
        paint(g);
    }

    public void run() {
        while(true) {
            try {
                Thread.sleep(10);
                repaint();
            } catch(Exception e) {
            }
        }
    }
}