/**
 * ގNX
 */

package library.graphics;

public class Material {
    double[] ambient, diffuse, specular, emission;
    int shininess;

    public Material() {
        this(Array.make(1.0, 1.0, 1.0));
    }
    public Material(double[] color) {
        ambient = color;
        diffuse = color;
        specular = color;
        emission = new double[3];
        shininess = 10;
    }
    public Material(double[] ambient, double[] diffuse, double[] specular, double[] emission, int shininess) {
        this.ambient = ambient;
        this.diffuse = diffuse;
        this.specular = specular;
        this.emission = emission;
        this.shininess = shininess;
    }

    public void setAmbient(double[] ambient) {
        this.ambient = ambient;
    }

    public void setDiffuse(double[] diffuse) {
        this.diffuse = diffuse;
    }

    public void setSpecular(double[] specular) {
        this.specular = specular;
    }

    public void setEmission(double[] emission) {
        this.emission = emission;
    }

    public void setShininess(int shininess) {
        this.shininess = shininess;
    }
}