/**
 * {NZNX
 */

package library.graphics;

//1̗̂Ƀf[^i[
public abstract class Voxel {
    public float[][][] density;
    public int num;

    public Voxel(int n) {
        density = new float[n][n][n];
        num = n - 1;
    }

    public boolean inner(double[] v) {
        if(v[0] >= -0.5 && v[0] < 0.5 && v[1] >= -0.5 && v[1] < 0.5 && v[2] >= -0.5 && v[2] < 0.5) return true;
        else return false;
    }

    public double getDensity(double[] v) {
        int ix, iy, iz;
        double x, y, z, x1, x2, x3, x4, y1, y2, z1;
        x = (v[0] + 0.5) * num;
        y = (v[1] + 0.5) * num;
        z = (v[2] + 0.5) * num;
        ix = (int)x;
        iy = (int)y;
        iz = (int)z;

        x1 = density[ix][iy][iz] + (x - ix) * (density[ix+1][iy][iz] - density[ix][iy][iz]);
        x2 = density[ix][iy+1][iz] + (x - ix) * (density[ix+1][iy+1][iz] - density[ix][iy+1][iz]);
        x3 = density[ix][iy][iz+1] + (x - ix) * (density[ix+1][iy][iz+1] - density[ix][iy][iz+1]);
        x4 = density[ix][iy+1][iz+1] + (x - ix) * (density[ix+1][iy+1][iz+1] - density[ix][iy+1][iz+1]);
        y1 = x1 + (y - iy) * (x2 - x1);
        y2 = x3 + (y - iy) * (x4 - x3);
        z1 = y1 + (z - iz) * (y2 - y1);

        return z1;
    }
}